/*
 * Decompiled with CFR 0.152.
 */
package com.jiuqi.util;

import java.util.Arrays;

public final class IntList {
    protected int size;
    protected int[] data;

    public IntList() {
    }

    public IntList(int capacity) {
        this.setCapacity(capacity);
    }

    public int size() {
        return this.size;
    }

    public void reset() {
        this.size = 0;
    }

    public void clear() {
        this.size = 0;
        this.data = null;
    }

    public int get(int index) {
        return this.data[index];
    }

    public void set(int index, int value) {
        this.data[index] = value;
    }

    public int add(int value) {
        int result = this.size;
        this.setSize(this.size + 1);
        this.data[result] = value;
        return result;
    }

    public void insert(int index, int value) {
        this.setSize(this.size + 1);
        int i = this.size - 1;
        while (i > index) {
            this.data[i] = this.data[i - 1];
            --i;
        }
        this.data[index] = value;
    }

    public void remove(int index) {
        int i = index;
        while (i < this.size - 1) {
            this.data[i] = this.data[i + 1];
            ++i;
        }
        this.setSize(this.size - 1);
    }

    public void setSize(int value) {
        if (value <= 0) {
            this.removeAll();
        } else if (value != this.size) {
            if (this.data == null || this.data.length < value) {
                this.data = IntList.resize(this.data, value);
            } else if (value > this.size) {
                int i = this.size;
                while (i < value) {
                    this.data[i] = 0;
                    ++i;
                }
            }
            this.size = value;
        }
    }

    public void setCapacity(int value) {
        if (value >= this.size) {
            this.data = IntList.resize(this.data, value);
        }
    }

    public void removeAll() {
        this.size = 0;
    }

    public void setAll(int value) {
        if (this.data != null) {
            Arrays.fill(this.data, value);
        }
    }

    public void plus(int index, int value) {
        int n = index;
        this.data[n] = this.data[n] + value;
    }

    public void setSmaller(int index, int value) {
        if (value < this.data[index]) {
            this.data[index] = value;
        }
    }

    public void setLarger(int index, int value) {
        if (value > this.data[index]) {
            this.data[index] = value;
        }
    }

    public int getTotal() {
        int value = 0;
        int i = 0;
        while (i < this.size) {
            value += this.data[i];
            ++i;
        }
        return value;
    }

    public int getTotal(int fromIndex, int toIndex) {
        int value = 0;
        int i = fromIndex;
        while (i <= toIndex) {
            value += this.data[i];
            ++i;
        }
        return value;
    }

    public boolean isEmpty() {
        return this.size == 0;
    }

    public void assign(IntList source) {
        this.setSize(source.size);
        IntList.copy(source.data, this.data, this.size);
    }

    public int indexOf(int value) {
        int i = 0;
        while (i < this.size) {
            if (this.data[i] == value) {
                return i;
            }
            ++i;
        }
        return -1;
    }

    public void removeValue(int value) {
        int index = this.indexOf(value);
        if (index >= 0) {
            this.remove(index);
        }
    }

    public int find(int value) {
        int sb = 0;
        int se = this.size - 1;
        int flag = -1;
        while (sb <= se) {
            int sp = sb + se >> 1;
            flag = value - this.data[sp];
            if (flag > 0) {
                sb = sp + 1;
                continue;
            }
            if (flag < 0) {
                se = sp - 1;
                continue;
            }
            sb = sp;
            break;
        }
        return flag == 0 ? sb : -sb - 1;
    }

    public int findFirst(int value) {
        int sb = 0;
        int se = this.size - 1;
        int flag = -1;
        while (sb <= se) {
            int sp = sb + se >> 1;
            flag = value - this.data[sp];
            if (flag > 0) {
                sb = sp + 1;
                continue;
            }
            if (flag < 0) {
                se = sp - 1;
                continue;
            }
            se = sp;
            if (sb == sp) break;
        }
        return flag == 0 ? sb : -sb - 1;
    }

    public int findLast(int value) {
        int sb = 0;
        int se = this.size - 1;
        int flag = -1;
        while (sb <= se) {
            int sp = sb + se + 1 >> 1;
            flag = value - this.data[sp];
            if (flag > 0) {
                sb = sp + 1;
                continue;
            }
            if (flag < 0) {
                se = sp - 1;
                continue;
            }
            sb = sp;
            if (se == sp) break;
        }
        return flag == 0 ? sb : -sb - 1;
    }

    public void sortAdd(int value) {
        int index = this.find(value);
        if (index < 0) {
            this.insert(-index - 1, value);
        }
    }

    public void sortAddLast(int value) {
        int index = this.findLast(value);
        if (index < 0) {
            this.insert(-index - 1, value);
        } else {
            this.insert(index + 1, value);
        }
    }

    public void exchange(int index1, int index2) {
        if (index1 != index2) {
            int t = this.data[index1];
            this.data[index1] = this.data[index2];
            this.data[index2] = t;
        }
    }

    public void move(int index1, int index2) {
        if (index1 > index2) {
            int t = this.data[index1];
            int i = index1;
            while (i > index2) {
                this.data[i] = this.data[i - 1];
                --i;
            }
            this.data[index2] = t;
        } else if (index1 < index2) {
            int t = this.data[index1];
            int i = index1;
            while (i < index2) {
                this.data[i] = this.data[i + 1];
                ++i;
            }
            this.data[index2] = t;
        }
    }

    public int getFirst() {
        return this.data[0];
    }

    public int getLast() {
        return this.data[this.size - 1];
    }

    public void push(int value) {
        this.add(value);
    }

    public int pop() {
        return this.data[this.size--];
    }

    public int[] toArray() {
        if (this.size == 0) {
            return null;
        }
        int[] result = new int[this.size];
        IntList.copy(this.data, result);
        return result;
    }

    public int toArray(int[] data) {
        IntList.copy(this.data, data, this.size);
        return this.size;
    }

    public static int[] resize(int[] data, int newSize) {
        newSize = newSize < 256 ? newSize + 63 & 0xFFFFFFC0 : (newSize < 4096 ? newSize + 255 & 0xFFFFFF00 : newSize + 4095 & 0xFFFFF000);
        int[] newData = new int[newSize];
        if (data != null) {
            IntList.copy(data, newData);
        }
        return newData;
    }

    public static void copy(int[] src, int[] dst) {
        if (src == null || dst == null) {
            return;
        }
        int count = src.length;
        if (count > dst.length) {
            count = dst.length;
        }
        int i = 0;
        while (i < count) {
            dst[i] = src[i];
            ++i;
        }
    }

    public static void copy(int[] src, int[] dst, int count) {
        if (src == null || dst == null) {
            return;
        }
        if (count > src.length) {
            count = src.length;
        }
        if (count > dst.length) {
            count = dst.length;
        }
        int i = 0;
        while (i < count) {
            dst[i] = src[i];
            ++i;
        }
    }

    public String toString() {
        StringBuffer sb = new StringBuffer(this.size() * 4);
        sb.append('(');
        int i = 0;
        while (i < this.size) {
            sb.append(this.data[i]);
            if (i < this.size - 1) {
                sb.append(',');
            }
            ++i;
        }
        sb.append(")");
        return sb.toString();
    }
}

